﻿Option Explicit On   ' Each variable must be declared well

Imports UserShareNet

Public Class Form1

    Dim is_try_ok As Byte   ' try ... catch state, 1: Ok, 0: error
    Dim temp_int16 As Int16  ' temporary used int16 value
    Dim temp_int32 As Int32  ' temporary used int32 value
    Dim temp_single As Single  ' temporary used 32-bit float value


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' enable timer1
        Timer1.Interval = 250  ' 250 ms
        Timer1.Enabled = True

    End Sub

    Private Sub ScanAI()

        Dim Value As Single

        Value = 0

        ' get AI value (short integer) at Address No. 9 to 12
        UserShare.Get_REAL(Convert.ToUInt16(9), Value)
        AI_Value1.Text = Value.ToString("0.000")     ' display 3 digit under "." symbol

        UserShare.Get_REAL(Convert.ToUInt16(10), Value)
        AI_Value2.Text = Value.ToString("0.000")

        UserShare.Get_REAL(Convert.ToUInt16(11), Value)
        AI_Value3.Text = Value.ToString("0.000")

        UserShare.Get_REAL(Convert.ToUInt16(12), Value)
        AI_Value4.Text = Value.ToString("0.000")

        ' Get Single at Address No.= 1 (AO 1)
        UserShare.Get_REAL(Convert.ToUInt16(1), Value)
        AO_Value1.Text = Value.ToString("0.000")  ' display 2 digit under "." symbol

    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' scan A/I every timer1 interval
        ScanAI()
    End Sub


    ' check if value is inside -10.0 to +10.0
    ' return 1:Ok , 0:Error
    Private Function check_87024(ByVal float_val As Single) As Byte
        If (float_val > 10.0) Or (float_val < -10.0) Then
            MsgBox("Value should be between -10.0 to +10.0 !")
            Return 0  ' error
        End If
        Return 1  ' ok
    End Function


    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        is_try_ok = 1  ' init as Ok
        Try
            temp_single = Convert.ToSingle(AO_Value4.Text)  ' for ex, if Value = 12AB.cd, error happens. However for ex.  Value = 1.15 is correct
        Catch
            is_try_ok = 0   ' error found
            MsgBox("Wrong value !")
        End Try

        If (is_try_ok = 0) Then  ' error found , return 
            Return
        End If

        ' check if value is correct
        If (check_87024(temp_single) = 0) Then
            Return
        End If

        ' write a real number to Address No.=4
        UserShare.Set_REAL(Convert.ToUInt16(4), temp_single)

    End Sub


    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        is_try_ok = 1  ' init as Ok
        Try
            temp_single = Convert.ToSingle(AO_Value3.Text)  ' for ex, if Value = 12AB.cd, error happens. However for ex.  Value = 1.15 is correct
        Catch
            is_try_ok = 0   ' error found
            MsgBox("Wrong value !")
        End Try

        If (is_try_ok = 0) Then  ' error found , return 
            Return
        End If

        ' check if value is correct
        If (check_87024(temp_single) = 0) Then
            Return
        End If

        ' write a real number to Address No.=3
        UserShare.Set_REAL(Convert.ToUInt16(3), temp_single)

    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        is_try_ok = 1  ' init as Ok
        Try
            temp_single = Convert.ToSingle(AO_Value2.Text)  ' for ex, if Value = 12AB.cd, error happens. However for ex.  Value = 1.15 is correct
        Catch
            is_try_ok = 0   ' error found
            MsgBox("Wrong value !")
        End Try

        If (is_try_ok = 0) Then  ' error found , return 
            Return
        End If

        ' check if value is correct
        If (check_87024(temp_single) = 0) Then
            Return
        End If

        ' write a real number to Address No.=2
        UserShare.Set_REAL(Convert.ToUInt16(2), temp_single)

    End Sub


End Class
